History of changes

ExportToFB2.1 Version 1.0
ExportToFB21 Convertor is remake of ExportToFictionBook (web: http://ifolder.ru/3048108). It is rewritten from scratch and includes additional functions. The author of original ExportToFictionBook is Thunder.

The ExportToFB2.1 is exciting convertor made with great idea in mind. Unfortunately that convertor supported only 2 levels of nested headers. By this reasons  I have decided to made it suite my needs. I have fully changed parsing of headers introducing ability to use endless nested headers levels in theory. Also I wished to made this confeverter conforming fb2.1 format as closer as it possible. In this version many things fully rewritten and existing was extended. Paragraph and footnote parsing was modernized. Introduced new algorithms,  while some procedures used from old source-code.
The main idea of this converter belongs to Thunder, and I want to say thank you to him for his work. I have contacted with the author of original converter and he granted me permission to use source-code of his converter in producing other software products.

ExportToFB2.1 Version 1.1
1. Additions: In documents that don't have single level (Header) with epigraph in beginnig of it such epigraph will not be included in <section> element. (In previous version it included. Inspite of this final document was still valid).

2. Corrections: In some documents with complicated structures on related levels there was no </section> element closure in final document. In result of it fb2 document was not valid. Now it is fixed.

ExportToFB2.1 Version 2.0

Document parser is fully rewritten from scratch, so now it has new features.


1. Export of tables with headers. Due to differences in fuctionality of OOo Writer 2.3 and versions below tables export have different results. For versions above 2.3 tables exporting only with one header (if it exists). In version 2.3 with all headers that was in original document. Converter have OOo Writer version detection feature and converts table depending on OOo version. For additional information on work with tables in document see p. 4.1.

2. Added export of footnotes which consists of several paragraphs (inluding formatting). In versions 1.0 and 1.1 there was only export of first paragraph of each footnote.

3. Export pictures tags and its titles (in "title" attribute of corresponding tag) in places where it needs (the pictures itself doesn't export for now).

4. Export of text insets (without formatting) as simple text, citation or table (see p. 4.2.).

5. Text fields export.

ExportToFB2.1 Version 2.1


1. Added option to define genre %.

2. Changed genre list - now choose genre name instead of genre code in past.

3. I have fixed text insets proccessing. In past if thare was Lines converter quits with exception.

4. Now sequentally numbered paragraphs and bullets exporting as «•» symbol before paragraph.

5. Introduced "Setup" dialog setting saving and option to restore defaults.

6. Introduced feature to load and to save document's author profile and Source OS («< <» and «> >» buttons respectivly).

7.On export dialog opening author's profile autoloaded if it exists and corresponding fields fills-in.

ExportToFB2.1 Version 2.2


1. Counter name fixed in pictures parser (picture number increment was not working).

2. fb2-file now created after document parsing. In past versions it is created before document parsing.

3. Rewritten numbered and bulleted text processing (aslo working in headers).

4. Text file for working with numbering was added.

5. Fixed error when Description element was written and in resulting it in fb2 <program-used> element data stay inaccessible.

6. Added option to setup user styles in corresponding window. (see p.3.7).

7. Fixed minor bugs and issues.

ExportToFB2.1 Version 2.3


1. Fixed crash when in document last element was Level, Epigraph, Poem, Citation.

2. Genre list extended in according with FictionBook Editor's v.2.0.

3. New text correction feature (cleaning tabulations and scapes, empty paragraphs, replace quotation signs etc.) (see p.II).

ExportToFB2.1 Version 2.4


1. Variables data types changed from Integer to Long (to remove restriction on long documents creation).

2. Fixed error when saved settings of Setup Dialog was ignored and default settings applied instead. In previous version settings red only after Setup Dialog opening and OK button pressing.

3. Added formatting check in blank paragraphs to skip unnecessary <strong></strong, <emphasis></emphasis> elemenets etc and <empty-line/> element in poems instead of <stanza> element.

4. Added new genres.

5. New text corrector replace line break with one space character.

6. New text corrector feature redefine picture anchor type. Useful when converting .doc files created in Microsoft Word. Such files opens in OOo Writer with all pictures anchored "as symbol". Now anchor type of this pictures can be redefined in text corrector (for book creation "to paragraph" or "to symbol" recommended).

7. Added optional feature to create links from one place inside document to another (for example link from poem's verse to annotation, link from footnote to citation). This option in Additional Settings dialog is turned off by default. When this option is turned on and converted document with lot of links of this kind - convertations process speed is slighty decreased. For additional information see p. 4.4.

8. Text document ExportToFB21_Test.odt updated. Now it is included  local document hyperlinks demo section.

ExportToFB2.1 Version 2.4.1


1. Footnotes convertion error fixed. In previous version if in the end of footnote's text there were link or hyperlink with no additional charactes its text was repeated twice.

2. Default fb2 document encoding changed from utf-8 to windows-1251.

3. Help files was updated.

ExportToFB2.1 Version 2.5


1. Optimized code for working with "User Styles".

2. Optimized "Text Corrector" settings saving and loading code.

3. Optimized "Additional Settings" dialog settings saving and loading code.

4. Fixed positining and look of dialogs controls. Now on Windows and Unix-like systems they don't get truncated captions.

5. Added author's profile loading confirmation as protection against accidental button "< <" clicking.

6. Made 6 virtual keyboards. For details see p.III

7. Help files was updated.





OOoFBTools-2.16
	A. Text Correction Tools:
		1. Text Corrector.
			a) For LibreOffice 4, removal of soft hyphens restored.
			
OOoFBTools-2.17
	A. Text Correction Tools:
		1. Text Corrector.
			a) For LibreOffice 4, a bug fixed: when deleting spaces between a quotation mark and a word the spaces between any character and the English letter B were deleted (bug in LO4+). Fixed.
	B. Converter:
		1. Improved handling of program listings.
		Now in the Settings dialog (the group of Miscellaneous), there is an new option of "Courier New font as determinant of program listings." Default is off. When it is activated, the converter will take all text in Courier New as a pointer to the fact that it is code of program listings or monospaced text, and, respectively, such text will be exported tagged as <code>.
		In previous versions of OooFBTools, the converter automatically took any text with this font as program listings, which resulted in export as program listing of any book formatted with Courier New font, even when it was no program listing.
		Now this is controllable with the new option in Settings.

OOoFBTools-2.18
	A. Converter:
		1. Improved handling of program listings.
	B. Text Correction Tools:
		1. Automatic markup for program listings:
			a) Introduced a feature of selection of the criterion for the identification of a text as a program listing: Paragraph font, Paragraph style, Character font, Character style.
			With the criteria for Characters is selected, the tool will format individual words with the Code style and Courier New font.
			When the criteria for Paragraphs is selected, the tool will format the found paragraphs with the Code style and Courier New font, and will replace multiple conventional spaces with non-breaking ones in those paragraphs.
			
OOoFBTools-2.19
	A. Converter:
		1. NEW: In the genres scheme selector, the scheme from LibRusEc added with a much larger number of genres.
		2. Bug fixed - the data of the FB2 properties dialog in the converter did not save upon clicking on Save fb2 properties, as it should be, but on exit. Fixed.
	B. Validator:
		1. NEW: The Validator now provides for selection of a FictionBook scheme. The fb2 LibRusEc scheme differs from fb2.1 or fb2.2 only by a much larger genres list. When validating, be careful in selecting the genres scheme. If a book is created with the support of the LibRusEc list of genres and the book has genres unique to this scheme, but you have chosen for the Validator the scheme of fb2.1 or fb2.2, the Validator will report an invalid fb2 file (and will be absolutely right).
	B. Help:
		1. Changes in the part of conversion - the selection of the genres scheme.
		2. Changes in the part of the Validator - the selection of the genres scheme.
	
OOoFBTools-2.20
	A. Converter:
		1. Fixed the old bug in the Genres handling.
		2. NEW: For Linux, FreeBSD, Mac OS X and other *nixes, fb2 files now can be validated after export (the on/off option is in the Converter settings). Previously, the validation worked only in Windows.
		To validate an fb2 file in a Unix system, xmllin utility must be installed (normally, it is included into the libxml2-utils package).
		3. Now, all messages of the fb2 file validation results have a uniform appearance in all operating systems.
	B. Validator Tool:
		1. NEW: For Linux, FreeBSD, Mac OS X and other *nixes, a selected fb2 file now can be validated. Previously, the validation worked only in Windows.
		2. Now, all messages of the fb2 file validation results have a uniform appearance in all operating systems.
	B. Text Correction Tools:
		1. Numbering of selected paragraphs:
			a) After a number, a non-breaking space is added.
		2. Inserting bullets at the beginning of specified paragraphs:
			a) After a bullet, a non-breaking space is added.
			b) The selection of bullets to insert is significantly expanded.
			
OOoFBTools-2.21
	A. Converter:			
		1. Critical update: Fixed image generation errors for Win 7/8
		
OOoFBTools-2.22
	A. General:
		1. As requested by Ukrainian users, for LibreOffice / Apache OpenOffice localized to Ukrainian the names of menu items, toolbars and messages from all tools and the Converter are displayed in Russian rather than in English
		2. The About OOoFBTools dialog is amended with information about OOoFBTools websites to download new releases.
	B. Text Correction Tools:			
		1. Text Corrector.
			a) Critical update: fixed error when inserting a non-breaking space in abbreviations.
		2. Interactive footnote generation:
			a) The tool operation improved.
			
OOoFBTools-2.23
	A. Text Correction Tools:
		Critical update: In LibreOffice 4.x and Apache OpenOffice 4.x, the search and replace with regular expressions is broken resulting in garbled document text.
		1. Text Corrector.
			a) A bug to fix in the option of Replace with dashes hyphens or minus signs used instead of dashes between words. Fixed.
			b) Replacing of multiple spaces between words with one space/tab now ignores superscipt/subscript numbers. Otherwise, the very first letter after such numbers was converted into superscipt/subscript.
		2. OCR formatting errors:
			a) Improved operation of the tool when processing quotes — looping protection.
			
OOoFBTools-2.24
	A. Converter:			
		1. NEW: Export of nested bulleted / numbered / picture lists in text, sidebars, tables. Nesting is simulated by non-breaking spaces, the number of which can be set in the Converter preferences. The default is 3 non-breaking spaces.
	B. Text Correction Tools:
		1. Text Corrector.
			a) Improved performance of Replace minus with n-dash between numbers. Now, it replaces with n-dashes not only minus signs, but also hyphens and m-dashes. Now, the option’s name is Replace minus, hyphen, m-dash with n-dash between numbers.
	
OOoFBTools-2.25
	A. Converter:			
		1. NEW: For all operating systems, the generation of a full GUID for fb2 file ID is implemented. If, for any reason, GUID could not be generated (uuidgen utility not found for Mac OS X, Linux and/or other system except Windows, or for another reason), the GUID is generated based on the time and the random number generator.
		Windows requires no extra software to install (the generator utility is included into OOoFBTools). For Mac OX X, Linux and other Unix systems, uuidgen must be installed. Usually it is installed by default in OS distros. To check this, run in the console: uuidgen. If uuidgen is installed, you will see the GUID. If it’s missing in the system, install uuid-runtime or libuuid1 package.
		2. Improved ergonomics of the Fb2 Properties Editor shape.
		3. Simplified post-processing: cleanup of the generated fb2 code.
		4. Slightly reduced dimensions of the Settings dialog to work on laptops.
	B. Text Correction Tools:
		1. Interactive footnote/endnote generation:
			a) NEW: Now the tools handles footnotes/endnotes numbered not only with superscript numbers, but also with digits with full stops (no superscript). For example: "4. Footnote/endnote text." Introduced search for footnote/endnote numbers in the note lists: 1. as numbers with full stops. 2. As superscript numbers. The color marking of footnote/endnote numbers in the text and the note lists is also dependent on the search mode selected.
		2. Text Corrector.
			a) NEW: Added an option to insert a non-breaking space between the day and the month, such as 19 January, January 19th…
			b) The form dimensions reduced to make it fit on 15" laptop screens of 1366x768 pixels. For this, the Corrector options are split to 2 selectable tabs: "Spaces, paragraphs, and breaks" and "Hyphens, dashes, and other."

OOoFBTools-2.26
	A. Converter:
		1. Due to different handling of text formatting by Open Office and LibreOffice, processing of empty tags such as <strong></strong>, <sup/><sup> etc. was improved. Now, no empty tag is left in the converted FB2 file irrespective of the office suite used.
		2. Improved handling of program listings when they contain text with bulleted/numbered lists.
	B. Text Correction Tools:
		1. Text Corrector.
			a) To the tab of “Hyphens, dashes, and other” a NEW group of “Numbered and bulleted lists” is added with the option of “Replace dash and hyphen bullets in direct speech with dashes or hyphens”. By default, the option is off. It is relevant to the literature that has direct speech (fiction books).
			The option takes into account some OCR features: Often when OCRing text, the markers of direct speech (m dash —, n-dash –, numerical dash, hyphen, minus hyphen -) are recognized by the OCR tool (FineReader) as bullets. And when converting, such direct speech with markers can be handled by the Converter not as direct speech but as a bulleted list, and the marker will be preceded by several space symbols (as set forth in the settings of the Converter). When this option is on during text correction, the Corrector will replace the markers of direct speech with the equivalent characters and remove the bulleted list marker in such paragraphs.
			For the Fiction profile, the option of “Replace dash and hyphen bullets in direct speech with dashes or hyphens” is turned on automatically. For other profiles it’s off. But for any profile you can turn it on/off manually.

OOoFBTools-2.27
	A. Converter:
		1. Added support of Flibusta web site genre schemes (fb2 properties dialog of the Converter and Favorite genres dialog).
		2. Small fixes of the Converter for generating better tag semantics.
	B. Validator:
		1. Added support of Flibusta site genres scheme.
	C. Text correction tools:
		1. Yoficator:
			a) Updated word base: now the word “отеле” is not replaced with “отёле”. This word is deemed an ambiguous word.
			
OOoFBTools-2.28
	A. General:
		1. The license version changed to GPLv3.
		2. Updated Help sections describing instruments for which modifications were implemented.
	B. Converter:
		1. Fb2 styles panel:
			a) New option: F1 … F10 for Headings. With this option enabled, the heading styles of Heading 1 … Heading 10 can be applied by pressing the F1 … F10 function keys. These keys will only work when the Fb2 styles panel is open! After closing the fb2 styles panel, the F1 … F10 keys don’t apply the Heading 1 … Heading 10 styles anymore and revert to their initial functions. The same happens after unticking “F1 … F10 for Headings” on the open fb2 styles panel.
		2. Fixed bug: when exporting endnotes, invalid fb2 was produced.
		3. When converting a document with images, manually restarting the office suite is no longer needed to correctly export images. The Converter will do it automatically. Restarting will occur only for a document containing bitmap or vector graphics, as well as text frames.
		4. Improved input of book dates. Previously, an invalid input of such a date resulted in invalid fb2.
		Date (text) is set as follows: YYYY. Date (value) is set as follows: YYYY-MM-DD. For clarity, visualizing of date input format for Date (text) and Date (value) is implemented. Also, when saving the set fb2 document properties verification of Book date compliance with this format and range is introduced, which must fit into the days of each month, and the months must be in the range from 01 to 12.
	B. Text Correction Tools:
		1. Text Corrector.
			a) Enhanced options of handling minus, dash and hyphen characters. Now, their combination with unbreakable spaces is taken into account.
			b) New option: Replace hyphens and minuses with dashes in direct speech.
			c) Fixed bug: In the words such as “Ye-e-e-ah,” “Uh-uh-uh,” etc. only the first hyphen was replaced with an m-dash. Now, all hyphens/minuses are replaced.
		2. NEW tool: Interactive conversion of nested tables to text. The tool will be useful for conversion to fb2 of a document containing nested tables (the converter won’t export such ones).
		3. Join Break Lines and Paragraphs Tool:
			a) Improved algorithm.
			b) NEW option for joining broken paragraph lines: Paragraph Indent. For details, see Help for Join Break Lines and Paragraphs Tool.
			c) NEW option for joining broken paragraph lines: Break of sentences in paragraph on lowercase letters, numbers, punctuation marks, quotation marks and parentheses. That is, BEFORE the break there can be any letter (UPPERCASE or lowercase), a closing quotation mark such as a double quotation mark or a guillemet, a closing parenthesis of any type, or a punctuation mark (,:,). But, as the name of the tool suggests, when a break is followed by the word starting with an UPPERCASE letter, no joining will happen. This limitation of the algorithm is introduced in order to prevent accidentally joining paragraphs and headings of text sections.
		4. Interactive Footnote Generation Tool:
			a) Improved algorithm intelligence.
			
OOoFBTools-2.29
	A. Converter:
		1. Improved handling of images in html files that embed graphics as base64 code (Open/LibreOffice cannot properly open and display such html, and the picture shows up as base64 code in the document text). The Converter would crash on such files.
		2. Improved handling of very long lines in document – the Converter would crash in some cases.
		3. An old bug fixed: freshly installed OOoFBTools (no settings file) produced incorrect export (no name for the Notes Section, incorrectly exported frames – as tables rather than structures…). Fixed.
		4. In version 2.28, export of footnotes with the text of complex structures was broken. Fixed.
		5. Now, a document is reloaded before export only when the document has bitmap images (with vector images and text frames in the text, reloading a document before conversion is no longer needed).
		6. Now, a check is performed to see if a fb2 file already exists. In the export dialog, a tick box is added that, when ticked, overwrites an existing fb2 file with a new one produced by the Converter. If unticked, and the fb2 file already exists, a message shows up about suggesting to change the name of the generated fb2  file.
		7. Increased number of kinds of exported vector graphics.
		8. NEW: Now, when a document has several bookmarks in the same paragraph with links there from different parts of the document, all such links will point to the paragraph. Previously, in such a situation only one link was operations, and other ones would point to nowhere.
	B. Text Correction Tools:
		1. Text Corrector.
			a) NEW option: Embedding graphics into a document. Very useful when working with a text that contains links to graphics located on the hard disk. With this option enabled, the Text Corrector embeds such images directly into the text (and they can be deleted from the hard drive). In other words, the images after processing are in the document. This option is enabled by default for all profiles of the Corrector.
			b) Improved processing logic for punctuation, quotation marks, brackets and minus sign, n/m-dashes, hyphens. This is particularly good for text recognized by the last release of FineReader 2012.
		2. NEW tool: "Delete all objects in document". Gives a choice to remove all objects such as:
			1) Text frames;
			2) Table (all or only nested in cells of other tables). Tables with protected cells are also removed;
			3) Bookmarks (all or unused only - which are not referred to by any object in the document);
			4) Bitmap graphics;
			5) Vector graphics;
			6) Embedded objects (OLE, charts, formulas, presentations, spreadsheets, flowcharts, LineArt lettering, etc.).
			
OOoFBTools-2.30
	A. Revised English localization of the tools (special thanks to Dmitri Gabinski):
		1. Search for OCR errors in text.
		2. OCR formatting errors:
		3. Join broken lines and paragraphs.
	B. Converter:
		1. Fixed bug. LibreOffice no longer could see the localized style name of Цитата, that is, began to perceive only Quotations (OpenOffice still works correctly with the localized style name of Цитата). This resulted in failure to export quotations. Fixed.
		2. Completely redesigned loading of styles to document. Now the styles are not loaded from templates but are created when the fb2 styles panel opens for the first time. This allowed to bypass the old bug in LibreOffice when in Windows 7.x/8.x the styles could load for tens of minutes depending on the document size. Now the fb2 styles panel launches almost instantly on any operating system.
		3. Fb2 properties editor:
			a) NEW: The paper book description data tab is amended with input fields for UDC, BBK and Copyright mark.
		4. The book description dialog (fb2 properties):
			a) NEW: The Custom Info tab is amended with a drop-down list of ready-made user-defined types: copyright, editor, etc.
	B. Text Correction Tools:
		1. The tool of Insert selected marker symbol to the beginning of selected paragraphs:
			a) Fixed bug that resulted in some cases in deletion of the first letter of a paragraph.
		2. NEW tool: Document formatting. Allows formatting a document according to specified criteria: page size and orientation, margins from the borders of paragraphs, typeface and font size, embedding graphic links into a document, and much more.
		
OOoFBTools-2.31
	A. Revised English localization of the tools (special thanks to Dmitri Gabinski):
		1. Text Corrector
		2. Clear paragraph formatting
		3. Placement of accent marks for Russian vowels
		4. QWERT -> ЙЦУКЕ -> QWERT
		5. Manual processing of paragraphs
	B. Converter:
		1. Fb2 styles panel
			a) Added a new code style for paragraphs and characters.
	B. Text Correction Tools:
		1. Clear paragraph formatting tool works again
		2. Text Corrector Tool:
			a) All options of processing minuses, hyphens and dashes now process minus signs (U+2212).
			b) Options for graphics processing removed.
		3. Automatic markup for program listings tool
			a) Fixed tool crashes.
		4. Document formatting tool:
			a) New options to change anchoring, text wrap, horizontal and vertical alignment for all graphics in document.
			
OOoFBTools-2.32
	A. Converter:
		1. A generated fb2 file would not validate with the LitRPG (sf_litrpg) genre of the Flibusta scheme. Fixed.
		2. Fb2 styles panel:
			a) Fixed the style creation algorithm. In certain situations, documents processed with older OOoFBTools versions are being formatted with fb2 styles in newer OOoFBTools versions. Due to a LO bug, the Quotation style won’t be created in a document. Therefore, such documents won’t contain the Quotation style when working with fb2 styles.
			Fixed. Now, the Quotation style will be created also for documents initially processed with older OOoFBTools versions and continued to be processed with newer OOoFBTools versions.
	B. Text Correction Tools:
		1. Document formatting tool:
			a) New option setting 0 character spacing (remove expanded or condensed spacing).
			b) New option setting 100% character scale width.
		2. In new LO 4.4.0, the Text formatting tool stopped working. Fixed.
		3. In new LO 4.4.0, the Delete objects tool stopped working. Fixed.

OOoFBTools-2.33
	A. Converter:
		1. Fixed bug: If there is only an image between headings, this results in an invalid fb2 file. Now, an empty paragraph is inserted after it.
		2. Fixed bug: In footnote/endnote text, only headings are present (in violation of the scheme). Protection for such cases is implemented.
		3. Fixed bug: In certain cases, the algorithm of generation of links from different paragraphs to different parts of the same paragraph failed. The algorithm has been rewritten from scratch. 
		4. Improved export of footnotes/endnotes with links.
		5. The export dialog, when displaying the converter progress, now displays the result for each step. I. e., the number of exported covers, footnotes/endnotes, etc. is displayed.  (RFE: https://sourceforge.net/p/fbtools/bugs/17/)
		6. Fb2 styles panel
			a) For the code style, new features added. Now, when the style code is applied to program listings, all multiple conventional spaces within simple text, as well as all single and multiple starting spaces are replaced by non-breaking spaces.
		7. Converter settings:
			a) Removed the option of Process empty tags (</x><x>, <x></x>, </x> <x> and <x> </ x>). (removal of tag pairs such as <strong/></strong>, </strong><strong>, <strong/> </strong>, </strong> <strong>, etc. in the generated fb2 file). Now, such tag pairs are always removed from the resulting fb2 file.
			b) NEW option: The group of Text preprocessing, the option of Remove unused bookmarks (nothing refers to them) in the entire document. By default, the option is off. This option is intended to remove all bookmarks that are not linked to from the document. Otherwise, in the resulting fb2 file such bookmarks will be converted to the attributes of tags id <p> / F?. Because nothing links to them in the text, those attributes will be redundant.
			If this option is enabled in the settings, after text pretreatment the document is automatically saved and reloaded. The dialog appears for export to the fb2 format.
		8. Fb2 properties editor:
			a) Tags of the book description for UDC, copyright now have attributes in both English and in Russian (RFE https://sourceforge.net/p/fbtools/enchancements/4/)
	B. Text Correction Tools:
		1. Automatic markup for program listings tool:
			a) Changed algorithm. Now, when analyzing the text and marking up program listings not only multiple spaces within the program listings, but also single starting spaces are converted to non-breaking spaces.
		2. Text Yofication tool:
			a) The word database is amdended with “всё-таки” (bug https://sourceforge.net/p/fbtools/bugs/16/).
		3. Delete all objects in document tool:
			a) Fixed bug: Now bookmarks not linked to are removed FROM ALL objects such as text, tables, frames, footnotes and endnotes.

OOoFBTools-2.34
	A. Converter:
		1). Fixed bug. When exporting docx files, in some cases fb2 file was invalid due to non-printable characters in docx (https://sourceforge.net/p/fbtools/discussion/general/thread/44c9d23a/).
		2). Fixed bug. Restored progress bar during document analysis.
		3). Fixed bug. When exporting a file without footnotes, the output file is still written with a footnotes section (bug https://sourceforge.net/p/fbtools/bugs/20/)
	B. Text Correction Tools:
		1. Text Corrector Tool:
			a) Fixed bug. If some text is pasted from the clipboard to Writer, the Corrector does not process all flaws, and after export some leading spaces in paragraphs remain (https://sourceforge.net/p/fbtools/discussion/general/thread/b2039d64/).
			
OOoFBTools-2.35
	A. Converter:
		1). Improved export of Unicode markers.
	B. Text Correction Tools:
		1. Text Corrector Tool:
			1). Fixed bug: Implemented processing of italics and bold attributes of dashes, spaces around them, and the first character of the word after a dash. Now, in such cases, the 1st character of a word has the same attributes as all other characters of that word.
			2). Fixed bug for LO: Improved removal of non-breaking spaces in the beginning of a paragraph when there is a line break instead of a paragraph break in the text.
			3). Fixed bug: crash on processing of hyphens and dashes.
			4). Fixed bug. Corrector crashes in certain cases when running the option of Replace with dashes hyphens or minus signs used instead of dashes between words.
			5). Fixed bug. in some cases, multiple spaces were not replaced with a selected number and type of space symbols.
			6). NEW group of options: Processing abbreviations, units of weight, volume, length
				a) From the group of options of Insert spaces, the option of Insert non-breaking spaces between family names and initials was moved here.
				b) From the group of options of Insert spaces, the option of Insert non-breaking spaces in abbreviations such as т.д., т.п., т.к., т.н., т.ч., т.е. was moved here.
				c) NEW option: Process abbreviations of units of weight, volume, length, quantity.
				d) NEW option: Process abbreviations in mailing addresses (ул., пос., кв. etc.).
				e) NEW option: Process endings of numerals (1900-е, 60-ые, 5-ть etc.).
				f) NEW option: Process words ending with numerals: Восход-1, Apollo XIII.
				g) NEW option: Process documents reduction: (tab., Fig., Ch. …).
			7). The group of options of Miscellaneous:
				a) NEW option: Process °C
				b) NEW option: Process %
				c) NEW option: Process spaces around ©, ®, ™, №, §
				d) NEW option: Replace +/- or +- before a number with ±
				e) NEW option: Remove spaces between symbols of paragraph and number: § § => §§, № № => №№
			8). Group of options of Insert spaces:
				a) Improved performance of the option of Insert spaces punctuation.
					1). Added processing of "stuck" digits, punctuation (except for full stops) and letters (such as: 450,and).
					2). Added inserting of a space after numbers, full stops and Russian letters (for example, 450.А (Rus)).
				b) NEW option: Insert spaces between Russian words and numbers (30машин, домов25)
			9). Group of options of Hyphens and dashes:
				a) Improved processing of hyphens, minus signs and dashes in situations where a hyphen, dash or minus sign "sticks" to the word on the right (for example: here it is —an example)
		2. OCR Formatting Errors Tool.
			a) Fixed a bug in processing of punctuation (algorithm rewritten).
			b) NEW option: Spaces around en/em-dash and first character after it. Introduced to detect italics and bold attributes (or no italics/no bold) of en/em dashes, spaces around them and the first character of the word after dashes.
		3. Footnote/Endnote Generator:
			a) NEW: Added an option to select generation of Footnotes or Endnotes.
			
OOoFBTools-2.36
	A. Converter:
		1) New: In ExportToFB21 Settings, a new option Set default book description is introduced (disabled by default). It is useful for export to fb2 without a detailed book description list. The book title and author data then are to be corrected in an FB2 editor.
	B. Text Correction Tools:
		1. Text Corrector Tool:
			a) Fixed bugs in the option group of Process abbreviations of units of weight, volume, length, quantity.
			b) Fixed bug in Remove spaces before punctuation, which severely modified texts duplicating chunks of text.
			c) The option of Insert a space between Russian words and numbers (30машин, на25) now is disabled for the profiles of Scientific literature and Technical literature. Otherwise, in the scientific literature spaces break chemical formulas and superscript/subscript numbers.
			d) Improved algorithm of Process %.
		2. Interactive footnote/endnote generation Tool:
			a) Fixed bug: in the latest version of LO the developers have changed the algorithm of bookmarks removal. This resulted in the tool no longer functioning properly. Fixed.
			b) NEW: Added an option to select the type of generated notes: footnote or endnote.
			
OOoFBTools-2.37
	A. Converter:
		1. Fb2 styles panel:
			a) NEW: When the panel loads, paragraphs such as "***", "* * *" are located and formatted with a localized Subheading style.
			b) To reduce the panel size, all Settings were moved to a separate page of the panel. Switching between fb2 styles and settings is performed by Styles – Settings radio buttons.
			c) The style list is divided into functional groups, each of which is highlighted for convenience.
		2. The Librusec genres scheme is amended supplemented with new genres from Librusec.
		3. All genres of all schemes are fully aligned with the schemes of fb2.1, Librusec and Flibusta respectively (old glitches fixed).
		4. All genres of all schemes are sorted by groups, alphabetically in groups, and Groups are sorted alphabetically.
		5. New presentation of all genres of all schemes: now they show up as a pseudotree. Navigation is easier and more intuitive.
		6. This change in genres of all the schemes is implemented also for localizations other than Russian or Ukrainian.
	B. Text Correction Tools:
		1. Document Formatting tool:
			a) NEW option: Remove all caps (takes time). An entire document is processed including text, tables, text boxes, footnotes, and endnotes.
			
OOoFBTools-2.38
	A. General:
		1. The old OOoFBTools site is replaced with the new one in the extension description (in Tools / Extension manager… ).
		2. In the About dialog, 2 assistants added: Sergei Starikov (site administrator) and Dmitri Gabinski (translator to English).
	B. Corrector:
		1. Fb2 styles panel:
			a) Changed the dimensions of the form elements (to fit in LO 5).
		2. Fb2 properties editor:
			a) For Custom info, the list of custom data expanded (cover, number of copies etc.).
	C. Text Correction Tools:
		1. Search for OCR errors in text Tool:
			a) In LO 5, the tool no longer works correctly. Fixed.
			
OOoFBTools-2.39
	A. Corrector:
		1. Fixed bug when processing line breaks (in LO, unlike in AOO, use of regular expressions for line breaks handling is broken) - https://sourceforge.net/p/fbtools/bugs/19/
		2. Processing abbreviations, units of weight, volume, length option: Fixed bug when inserting non-breaking spaces in abbreviations (a non-breaking space was inserted even in words beginning with abbreviations in question) - (https://sourceforge.net/p/fbtools/bugs/22/)
		3. Remove spaces inside quotation marks option: Fixed old bug when spaces were not removed. Works only for guillemots « and » (https://sourceforge.net/p/fbtools/bugs/23/)
	B. Text Correction Tools:
		1. Yoficator:
			a) LO would enter into an infinite loop because of yet another thing broken by LO developers in the UNO structures mechanism (no such problem in AOO). Fixed.
			b) The word base of Yoficator amended with the word умён (https://sourceforge.net/p/fbtools/bugs/26/).
		2. Search for OCR errors in text Tool: For the search mode of Paragraph break on words, punctuation marks, quotation marks and brackets, a field is introduced to enter punctuation marks, brackets, quotation marks for search. You can specify particular characters that you need. The Restore button restores the character set in this field to the default. (https://sourceforge.net/p/fbtools/bugs/15/)
		IMPORTANT: Since the search uses regular expressions, a closing square bracket in the character field must be preceded by a \ character (as defined in the default character set).
		
OOoFBTools-2.40
	A. Converter:
		1. Fb2 styles panel:
			a) Default style added.
			b) Clear Format button added that resets paragraph formatting without changing its style.
		2. Genre of Occultism added to the genres list
		3. Genre of Archeology added to the genres list.
		
OOoFBTools-2.41
	A. General:
		1. Fixed an error (overflow) in many tools for text processing, when the text has more than 32,000 bookmarks, or hyperlinks, or footnotes...
	B. Converter:
		1. Fixed bug: Converter crashes in case when one paragraph has several bookmarks that need to be converted to the tag IDs of <p> to refer to this paragraph, and in the Converter settings the option of Remove unused bookmarks (nothing refers to them) in the entire document is disabled
		2. In paragraph IDs, characters other than letters and numbers (a bookmark name in text contains illegal characters) are replaced with the underscore symbol _. Otherwise, an invalid fb2 file was produced.
	C. Text Correction Tools:
		1. Clear paragraph formatting tool renamed to Change style to Default.
		
OOoFBTools-2.42
	A. Converter:
		1. Fixed errors in the genres scheme.
		2. The dimensions of the fb2 Styles panel reduced (the new release of LO has fixed the bug when the user panel dimensions could randomly change).
	B. Text Correction Tools:
		1. Virtual keyboards:
			a) The Russian ruble and the Ukrainian hryvnia symbols added to the currency keyboard (thanks to Dmitri Gabinski).
			
OOoFBTools-2.43
	A. General:
		1. Fixed errors in the help.
		2. Fixed bug: the position of forms in all dialogs of the tools did not restore after their launch.
		3. Fixed many minor bugs in various tools.
	B. Converter:
		1. Fixed incorrect display of some genres in the Groups of genres.
		2. NEW option in the export dialog: Zip fb2 file (.fb2.zip).
		3. Fixed bug of incorrect export of medium complexity tables.
		
OOoFBTools-2.44
	A. Converter:
		1. NEW: Filename extension for zip archive is selectable: .fb2.zip or .fbz.
		2. FIXED BUG: For Windows, fixed a bug of Converter crashing while archiving a fb2 file.
		2. FIXED BUG: Fixed a bug of Converter crashing while saving settings.

OOoFBTools-2.45
	A. Converter:
		1. FIXED BUG for Windows: When exporting with the option to create a zip archive, a rar archive was created instead, which many readers could not read. The archiver replaced with 7za.
		2. For Unix-like systems: Improved generation of book id (GUID).
		3. For Unix-like systems: introduced checks for required additional tools (uuidgen, zip, xmllint, base64, openssl) with messages if no required utility is installed in the system.
		4. For Unix-like systems: Images are exported using either base64 or openssl. Therefore, installing only one of them is sufficient.
		5. For Unix-like systems: improved display of the result of fb2 file validation.
	B. Interactive Footnote Generation Tool:
		1. The list of "Template for number of note in list" amended with the template "x ...." - Footnote number without a full stop.
	C. Validator:
		1. For Unix-like systems: introduced check for required additional tool of xmlling with a message prompting to install it when not installed in the system.
		
OOoFBTools-2.46
	A. Converter:
		1. Fixed BUG: When a document contains only endnotes or only footnotes and "Export of footnotes and endnotes to a common block" is selected in settings, the text of footnotes/endnotes would not export. Fixed (https://sourceforge.net/p/fbtools/bugs/27/)
		2. If a created fb2 file is compressed to a zip archive, the intermediate fb2 file is deleted. (https://sourceforge.net/p/fbtools/bugs/29/)
		3. If a created fb2 file is compressed to a zip archive, the output of the validation result will specify the correct filename extension (https://sourceforge.net/p/fbtools/bugs/27/).
		4. The name of the fb2 file inside a zip archive is saved with transliteration. (https://sourceforge.net/p/fbtools/bugs/30/)
		5. For UNIX: When compressed to a zip archive, an fb2 file would be archived with folders where it is located. Now archives contain only fb2 files.(https://sourceforge.net/p/fbtools/bugs/30/)

OOoFBTools-2.47
	A. Converter
		1. Fb2 styles panel: Now the base FB2 style has the name of the office suit Default style font.
		2. Fixed bug: when compressing a created FB2 file, if the filename was in Latin script, an error emerged and no archive could be produced. Fixed (https://sourceforge.net/p/fbtools/bugs/32/)
		3. For Unix-like systems: no zip utility is required in the system. Book ID is generated by Python (https://sourceforge.net/p/fbtools/bugs/31/)
		4. For Unix-like systems: no openssl or base64 utility is required in the system. Images are coded into base64 by Python.
		5. For Unix-like systems: no zip utility is required in the system. Compression is made by Python.
	B. Text Correction Tools:
		1. Yoficator:
		a) Database amended (https://sourceforge.net/p/fbtools/bugs/25/)

OOoFBTools-2.48
	А. Converter
		1. Converter settings: NEW option “FB2 Styles Formatting” (requested by users). Default is off. When it is off, while downloading fb2 styles, the styles Heading 1 … Heading 10, Subheading and Default have standard formatting as defined in the office suite settings (color, indentation, font size, font name, etc.). However, when FB2 Styles Formatting is on, the formatting of these styles will change to the pre-sets for the fb2 styles. The conversion will not absolutely be affected by this option, only the appearance of the document will.
	B. Text Correction Tools:
		1. Text Corrector:
			a) Fixed incorrect operation of the option Insert spaces between Russian words and numbers (30машин, домов25): the bug was in garbled text with superscript numbers: such numbers would lose their superscript formatting, which distorted texts with formulas (extent of numbers), paragraphs with superscript numbers, superscript numbering for footnotes in text… Fixed.
			b) Fixed a bug in the option of Replace hyphen-minus with hyphen in clarification words (https://sourceforge.net/p/fbtools/bugs/33/)
		2. Footnote/Endnote Generator: Document test mode:
			а). Fixed bug: When report listed ordered numbers of zones (bookmarks), all the numbers were equal to 0.
			b) Improved readability of the report: Now it displays data only for those chapters and lists of footnotes/endnotes (search area) that require corrections of note (footnote/endnote) numbers in chapter texts and/or lists of notes. Search areas, where no correction of note numbers is required, do not appear.
			c) Improved algorithm: Now, when there is a full correspondence between the numbers of footnotes/endnotes in the text and the numbers of notes in the lists of notes, but the order is not consecutive (for example, 1, 5, 3, 2…), the Test works correctly. Previously, the Test would work correctly only in the case of a consecutive order of footnotes/endnotes (1, 2, 3, 4, 5…)
		2. Footnote/Endnote Generator: Generation mode:
			a) Improved algorithm: Now, when there is a full correspondence between the numbers of footnotes/endnotes in the text and the numbers of notes in the lists of notes, but the order is not consecutive (for example, 1, 5, 3, 2…), the generation works correctly. Previously, the generation would work correctly only in the case of a consecutive order of footnotes/endnotes (1, 2, 3, 4, 5…)
			
OOoFBTools 2.49
	A. Tools Text corrections:
		1. Text Corrector:
			a). The bug: "Falling" of the Text Corrector on inserting a space between a word and a number in footnotes.

OOoFBTools-2.50
	1. Adapted for LibreOffice 5.3.1.2 (https://sourceforge.net/p/fbtools/bugs/34/)

OOoFBTools-2.51
	A. Converter
		1. For Linux, improved export of images.
		2. NEW: If paragraphs of regular text are centered, then the tag <p> becomes <p style="text-align:center;"> (https://sourceforge.net/p/fbtools/enchancements/10/)
	B. Text Correction Tools:
		1. Delete all objects in document:
			a) NEW: Option “All hyperlinks”. Allows removing all hyperlinks from the document.
			

OOoFBTools-2.52
	A. General:
		1. Revised translation of names of all tools for the menu and the toolbar (by Yury Tarasievich).
	B. Text Correction Tools:
		1. Text Corrector:
			a) Fixed old bug: insertion of '\n' instead of a new line special character in LO (https://sourceforge.net/p/fbtools/bugs/35/).

			
OOoFBTools-2.53
	A. Converter
		1. Fixed bug: in some cases the Converter lost data from cells of complex tables containing cells with nested tables.
		2. Fixed bug: in some cases the Converter crashed on complex tables containing cells with nested tables.
		3. When launching the Converter, a check is made for tables in the document containing other tables nested in cells. If any, a warning is issued that the data of the nested tables will be ignored by the Converter and will be lost in the resulting FB2 file. It is suggested to choose one of 3 options: Continue conversion, or Stop conversion, or launch the tool of Interactive conversion of nested tables to text.
		4. New: Export of paragraphs aligned to the right (centered was implemented earlier). In the Settings dialog, a new option introduced to enable/disable export for paragraph alignment (“Paragraph Alignment”). By default, the opti
		5. Fixed bug: error if the document has a table-frame.
	B. Text Correction Tools:
		1. Fixed bug: error if the document has a table-frame.

OOoFBTools-2.54
	A. Converter
		1. Ensured compatibility with LibreOffice 6.1 (https://sourceforge.net/p/fbtools/bugs/36/)
		2. Fixed old bug: If no empty line were present between images, then a fb2 file was not valid. Now, <empty-line /> is inserted between images.
	B. Text Correction Tools:
		1. Convert nested tables to text:
			a) Ensured compatibility with LibreOffice 6.1
		2. Embedding graphics into a document.
			a) Ensured compatibility
			

OOoFBTools-2.55
	A. Converter
		1. On Windows, zip compression is done by zip utility from Windows.
	B. Text Correction Tools:
		1. Fixed bug: the option "Insert a space between a Russian word and a number" works in text, in footnotes, in tables, in textframes.
		
OOoFBTools-2.56
	A. Converter
		1. Fixed incorrect compression algorithm in zip for Windows. Now subfolders are not included in the zip file.
		2. Fixed a bug in the converter on vector shapes and pictures (https://sourceforge.net/p/fbtools/bugs/38/). Now all vector shapes are exported again. Only vector lines are not exported.
		
OOoFBTools-2.57
	A. Aligning tools with changes to LibreOffice 6.4
		1. Removed duplicate variable definitions that caused an error message to appear in the new office.
		

OoFBTools-3.0.
	A. Added support for the genres scheme from Coollib and Litvek libraries. 

OoFBTools-3.1.
	A. Converter
		1. Fixed bug: In the FB2 dialog, the properties did not save / did not load the setting for the genre scheme from the Coollib and Litvek libraries.
		2. Updated the genres scheme from Coollib and Litvek libraries.

OoFBTools-3.2
	A. Converter:
		1. Fixed a bug of the incorrect definition of the CollLib of the library genre.
		2. Fixed the bug of the wrong definition of the genre scheme for the CollLib library when validated after export. 
		
OoFBTools-3.3
	A. Converter:
		1. Fixed the bug of incorrect definition of the Genre code of all schemes.
		
OOoFBTools-3.4
	А. Converter:
		1. Updated the genres scheme from Coollib and Litvek libraries.
		
OOoFBTools-3.4.1
	А. Converter:
		1. Fixed the bug encoding the list of genres from the library the CollLib library.
		
OOoFBTools-3.5
	А. Converter:
		1. Updated the genres scheme from Coollib and Litvek libraries.
		
OOoFBTools-3.5.1
	А. Converter:
		1. The current year has been changed in the 'About...' dialog.
